#ifndef   __ZLG600A_DCP_Drive__H
#define   __ZLG600A_DCP_Drive__H
//#include "CommDefine.h"
#ifdef __cplusplus
extern "C" {
#endif

#define   MYAPI     __stdcall
#define   UCHAR     unsigned char
#define   UINT      unsigned int

#define  MAX_SER_SIZE   272
#define  CommandOk   0          //ִгɹ
#define  CommandErr  1          //ִʧ

#define  KEYA   0x60          //AԿ
#define  KEYB   0x61          //BԿ
#define  AddValue  0xC1       //ֵ
#define  DecValue  0xC0       //ֵ

//ZLG600A-DCPͨЭغ궨
#define  STX  0x02    //ʼֽ
#define  ETX  0x03    //ֽ
#define  NAK  0x15    //Уʶ

#define  Start       0  //Эʼֽ
#define  Data_len_H  1  //ݳȸֽ
#define  Data_len_L  2  //ݳȵֽ
#define  Command_H   3  //ֽ
#define  Command_L   4  //ֽ
#define  Statues_H   3  //״ֽ̬
#define  Statues_L   4  //״ֽ̬
#define  Info        5  //

#define  Formatlength 5  //Э̶ȣܳݳ+5
//============================================================================

typedef  unsigned char (* PH_DATE)(unsigned char *DataBuff,  int length);//void͵һָ룬ڴݷͺͽ̬ܺ
typedef  void (*PH_DELAY)(long times);//
typedef struct _CardActiveInfo{            
	unsigned char CardType;           //Ƭ0x0A--TypeA0x0B--TypeB0x1A--M1
	unsigned char UIDLength;          //Ƭкų
	unsigned char ucUID[10];          //ƬкŴ
	unsigned char ATRLength;          //ƬλӦϢ
	unsigned char ATRData[50];        //ƬλӦϢ

}T_CardActiveInfo;//忨ƬϢݽṹ

typedef struct __APDUSendPara{ 
	unsigned char Code[300];    //Ĳ
	unsigned int length;     //
	unsigned char WTXM_CRC;
	unsigned char FWI;         //ʱȴʱ
}APDUSendPara;//ڲľ庬οZLG600SPûֲݽ



typedef struct __APDUReceivePara{
	unsigned char Data[300];    //
	unsigned int length;       //Ч	
}APDUReceivePara;

T_CardActiveInfo CardActiveInfo;        //ƬϢṹ
APDUSendPara g_APDUSend;              //APDU
APDUReceivePara g_APDUGet;            //APDUղ
//ȫֱ
unsigned char g_ucSerBufS[MAX_SER_SIZE];		    // ݷͻ
unsigned char g_ucSerBufR[MAX_SER_SIZE];		    // ݽջ


///////////////////////////////////////////////////////////////////////////////////////////////////
// :    עⲿݽա͡ʱ̬
// :    PH_DATE DataSent    :   ⲿݷͺַ
//              PH_DATE DataGet     :   ⲿݽպַ
//              PH_DELAY TimeDelay	:  	ⲿʱַ
// :    -
//   ֵ:    
///////////////////////////////////////////////////////////////////////////////////////////////////
void MYAPI OutSideRegister(PH_DATE DataSent,PH_DATE DataGet,PH_DELAY TimeDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
// :    ZLG600A-DCPģͨѶú
// :    UCHAR BDRNum  0x00òΪ 9600  
//                            0x01òΪ 19200 
//                            0x02òΪ 38400 
//                            0x03òΪ 57600 
//                            0x04òΪ 115200  	
// :    
// ֵ:    0---ɹ      1-----ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI ZLG600A_DCP_SETBDR(unsigned char BDRNum);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    ȡ豸ͺż汾Ϣ
// :    unsigned char *pDvcInfo       : ⲿڽݵַ鳤Ҫ20
//				unsigned char *Dlen           :ģ汾Ϣ
// :    豸ͺż汾Ϣ				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI GetDvcInfo(unsigned char *pDvcInfo,unsigned char *Dlen);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    ģƺ
// :    UINT time,        ʱ
//			    UCHAR tiems	      д
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI SET_Beep(UINT time,UCHAR tiems);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    ģLEDƺ
// :    UCHAR LED_Set        BIT7Ӧ̵ƣ0-ص 
//                                                 1- 
//                                   BIT6Ӧƣ0-ص 
//                                                 1- 
//                                   BIT5~0Ԥ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI SET_LED(UCHAR LED_Set);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    ģƵź
// :    
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI RF_OPEN(void);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    رģƵź
// :    
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI RF_OFF(void);



/**************************************************************************************************/
//////////////////////////////////////////////////////////////////////////
////////                      CPU                 //////////////////
//////////////////////////////////////////////////////////////////////////
/**************************************************************************************************/
///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    Ӵʽϵ
// :    UCHAR DelayTimeH,     ʵ壬ֵ
//              UCHAR DelayTimeL,     ʵ壬ֵ
//              UCHAR index           0x10 SAM1
//                                          0x11 SAM2
//              UCHAR *RestInfo        Ƭϵ󷵻صĸλϢŵַ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI Slot_PowerON(UCHAR DelayTimeH,UCHAR DelayTimeL,UCHAR index,UCHAR *RestInfo);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    Ӵʽϵ
// :   UCHAR index            0x10 SAM1
//                                          0x11 SAM2
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI Slot_PowerOFF(UCHAR index);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    ǽӴ
// :   UCHAR Delaytime_H,           ------Delaytimeֽ
//             UCHAR Delaytime_L,           ------Delaytimeֽ
//     DelayTime˵2 Bytes ȴӦʱ䣬ֽǰֽں 
//     DelayTime=0ʱӦ޿ֱӷʧܣ 
//     DelayTime=0xffff ʱһֱѰֱпӦ 
//     DelayTimeΪֵʱ DelayTimeһֱжϿǷӦλ룩
//            
// :   T_CardActiveInfo *CardActiveInfo  ------ƬϢṹָ				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI Active_ICCard(UCHAR Delaytime_H,UCHAR Delaytime_L,T_CardActiveInfo *CardActiveInfo);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    APDU
// :   UCHAR index            0x10 SAM1
//                                          0x11 SAM2
//             UCHAR *APDUBuff        Ҫ͵APDU׵ַ
//             UCHAR APDU_Len         Ҫ͵APDU
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI Send_APDU(UCHAR index,APDUSendPara *APDUSend,APDUReceivePara *APDUGet);


/**************************************************************************************************/
/////////////////////////////////////////////////////////////////////////////
////////                      M1                 //////////////////
/////////////////////////////////////////////////////////////////////////////
/**************************************************************************************************/
///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    APDU
// :   UCHAR KeyType          Կֽڣ0x60----KEYA;0x61-----KEYB
//             UCHAR *pUid            ƬUIDŵַֻ贫4ֽڼɣ7ֽIDĿڶͻص4ֽIDɣ
//             UCHAR *pKey            6ֽ֤Կַ
//             UCHAR Block            Ҫ֤׿Եַ0Ϊ01Ϊ42Ϊ8
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI M1_AuthKey(UCHAR KeyType,UCHAR *pUid,UCHAR *pKey,UCHAR Block);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    M1
// :   UCHAR *pBlockData,     ŶݵĻַ
//             UCHAR Block            ҪȡĿĿԵַ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI M1_ReadBlock(UCHAR *pBlockData,UCHAR Block);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    M1д
// :   UCHAR *pBlockData,     Ҫдݵ׵ַ16ֽڣ
//             UCHAR Block            ҪдĿĿԵַ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI M1_WriteBlock(UCHAR *pBlockData,UCHAR Block);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    M1ֵֵ
// :   INT32 Value     32Ϊзŵֵ
//             UCHAR Block     ֵҪдĿĿԵַ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI M1_SetValue(int Value,UCHAR Block);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    M1ȡֵֵ
// :   INT32 *pValue     Ŷֵ32Ϊзŵֵ
//             UCHAR Block     ֵҪдĿĿԵַ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI M1_ReadValue(int *pValue,UCHAR Block);

///////////////////////////////////////////////////////////////////////////////////////////////////    
// :    M1ֵֵֵ
// :   UCHAR Mode       ģʽֵǿ۷
//             UCHAR SBlock     Դֵĵַ
//             INT32 Value      ֵ32λзֵ
//             UCHAR DesBlock   ſַ
//˵ҪдݱҪֵĸʽɲο S50ֲᡣԴֵ
//ſͬ򽫲ĽдԭĿڣԴֵſŲͬ
//򽫲ĽдſڣſݱǣԴڵֵ
// :    				
//   ֵ:    0ִгɹ    ʧ
///////////////////////////////////////////////////////////////////////////////////////////////////
unsigned char MYAPI M1_OperValue(UCHAR Mode,UCHAR SBlock,int Value,UCHAR DesBlock);
#ifdef __cplusplus
}
#endif


#endif